%module glibtop

%init
%{
  pyglibtop_init();
%}

extern PyObject* get_cpu();

extern PyObject* get_mem();

extern PyObject* get_swap();

extern PyObject* get_uptime();

extern PyObject* get_loadavg();

extern PyObject* get_proclist(long long which, long long arg);

extern PyObject* get_proc_state(long pid);

extern PyObject* get_proc_uid(long pid);

extern PyObject* get_proc_mem(long pid);

extern PyObject* get_proc_time(long pid);

extern PyObject* get_proc_signal(long pid);

extern PyObject* get_proc_kernel(long pid);

extern PyObject* get_proc_segment(long pid);

extern PyObject* get_proc_args(long pid);

extern PyObject* get_proc_map(long pid);

extern PyObject* get_netload(const char *interface);

extern PyObject* get_ppp(unsigned short device);

extern PyObject *get_mountlist(int allfs);

extern PyObject *get_fsusage(const char *mount_dir);



#define	MOUNTENTRY_LEN	79
#define	CPU_TOTAL	0
#define	CPU_USER	1
#define	CPU_NICE	2
#define	CPU_SYS	3
#define	CPU_IDLE	4
#define	CPU_FREQUENCY	5
#define	XCPU_TOTAL	6
#define	XCPU_USER	7
#define	XCPU_NICE	8
#define	XCPU_SYS	9
#define	XCPU_IDLE	10
#define	MAX_CPU	12
#define	NCPU	4
#define	LOADAVG_LOADAVG	0
#define	LOADAVG_NR_RUNNING	1
#define	LOADAVG_NR_TASKS	2
#define	LOADAVG_LAST_PID	3
#define	MAX_LOADAVG	4
#define	MEM_TOTAL	0
#define	MEM_USED	1
#define	MEM_FREE	2
#define	MEM_SHARED	3
#define	MEM_BUFFER	4
#define	MEM_CACHED	5
#define	MEM_USER	6
#define	MEM_LOCKED	7
#define	MAX_MEM	8
#define	SWAP_TOTAL	0
#define	SWAP_USED	1
#define	SWAP_FREE	2
#define	SWAP_PAGEIN	3
#define	SWAP_PAGEOUT	4
#define	MAX_SWAP	5
#define	PPP_STATE	0
#define	PPP_BYTES_IN	1
#define	PPP_BYTES_OUT	2
#define	MAX_PPP	3
#define	PPP_STATE_UNKNOWN	0
#define	PPP_STATE_HANGUP	1
#define	PPP_STATE_ONLINE	2
#define	NETLOAD_IF_FLAGS	0
#define	NETLOAD_MTU	1
#define	NETLOAD_SUBNET	2
#define	NETLOAD_ADDRESS	3
#define	NETLOAD_PACKETS_IN	4
#define	NETLOAD_PACKETS_OUT	5
#define	NETLOAD_PACKETS_TOTAL	6
#define	NETLOAD_BYTES_IN	7
#define	NETLOAD_BYTES_OUT	8
#define	NETLOAD_BYTES_TOTAL	9
#define	NETLOAD_ERRORS_IN	10
#define	NETLOAD_ERRORS_OUT	11
#define	NETLOAD_ERRORS_TOTAL	12
#define	NETLOAD_COLLISIONS	13
#define	MAX_NETLOAD	14
#define	IF_FLAGS_UP	1
#define	IF_FLAGS_BROADCAST	2
#define	IF_FLAGS_DEBUG	3
#define	IF_FLAGS_LOOPBACK	4
#define	IF_FLAGS_POINTOPOINT	5
#define	IF_FLAGS_RUNNING	6
#define	IF_FLAGS_NOARP	7
#define	IF_FLAGS_PROMISC	8
#define	IF_FLAGS_ALLMULTI	9
#define	IF_FLAGS_OACTIVE	10
#define	IF_FLAGS_SIMPLEX	11
#define	IF_FLAGS_LINK0	12
#define	IF_FLAGS_LINK1	13
#define	IF_FLAGS_LINK2	14
#define	IF_FLAGS_ALTPHYS	15
#define	IF_FLAGS_MULTICAST	16
#define	UPTIME_UPTIME	0
#define	UPTIME_IDLETIME	1
#define	UPTIME_BOOT_TIME	2
#define	MAX_UPTIME	3
#define	PROCLIST_NUMBER	0
#define	PROCLIST_TOTAL	1
#define	PROCLIST_SIZE	2
#define	MAX_PROCLIST	3
#define	KERN_PROC_ALL	0
#define	KERN_PROC_PID	1
#define	KERN_PROC_PGRP	2
#define	KERN_PROC_SESSION	3
#define	KERN_PROC_TTY	4
#define	KERN_PROC_UID	5
#define	KERN_PROC_RUID	6
#define	KERN_PROC_MASK	15
#define	EXCLUDE_IDLE	4096
#define	EXCLUDE_SYSTEM	8192
#define	EXCLUDE_NOTTY	16384
#define	PROC_STATE_CMD	0
#define	PROC_STATE_STATE	1
#define	PROC_STATE_UID	2
#define	PROC_STATE_GID	3
#define	MAX_PROC_STATE	9
#define	PROC_UID_UID	0
#define	PROC_UID_EUID	1
#define	PROC_UID_GID	2
#define	PROC_UID_EGID	3
#define	PROC_UID_PID	8
#define	PROC_UID_PPID	9
#define	PROC_UID_PGRP	10
#define	PROC_UID_SESSION	11
#define	PROC_UID_TTY	12
#define	PROC_UID_TPGID	13
#define	PROC_UID_PRIORITY	14
#define	PROC_UID_NICE	15
#define	MAX_PROC_UID	18
#define	PROC_MEM_SIZE	0
#define	PROC_MEM_VSIZE	1
#define	PROC_MEM_RESIDENT	2
#define	PROC_MEM_SHARE	3
#define	PROC_MEM_RSS	4
#define	PROC_MEM_RSS_RLIM	5
#define	MAX_PROC_MEM	6
#define	PROC_TIME_START_TIME	0
#define	PROC_TIME_RTIME	1
#define	PROC_TIME_UTIME	2
#define	PROC_TIME_STIME	3
#define	PROC_TIME_CUTIME	4
#define	PROC_TIME_CSTIME	5
#define	PROC_TIME_TIMEOUT	6
#define	PROC_TIME_IT_REAL_VALUE	7
#define	PROC_TIME_FREQUENCY	8
#define	PROC_TIME_XCPU_UTIME	9
#define	PROC_TIME_XCPU_STIME	10
#define	MAX_PROC_TIME	11
#define	PROC_SIGNAL_SIGNAL	0
#define	PROC_SIGNAL_BLOCKED	1
#define	PROC_SIGNAL_SIGIGNORE	2
#define	PROC_SIGNAL_SIGCATCH	3
#define	MAX_PROC_SIGNAL	4
#define	PROC_KERNEL_K_FLAGS	0
#define	PROC_KERNEL_MIN_FLT	1
#define	PROC_KERNEL_MAJ_FLT	2
#define	PROC_KERNEL_CMIN_FLT	3
#define	PROC_KERNEL_CMAJ_FLT	4
#define	PROC_KERNEL_KSTK_ESP	5
#define	PROC_KERNEL_KSTK_EIP	6
#define	PROC_KERNEL_NWCHAN	7
#define	PROC_KERNEL_WCHAN	8
#define	MAX_PROC_KERNEL	9
#define	PROC_SEGMENT_TEXT_RSS	0
#define	PROC_SEGMENT_SHLIB_RSS	1
#define	PROC_SEGMENT_DATA_RSS	2
#define	PROC_SEGMENT_STACK_RSS	3
#define	PROC_SEGMENT_DIRTY_SIZE	4
#define	PROC_SEGMENT_START_CODE	5
#define	PROC_SEGMENT_END_CODE	6
#define	PROC_SEGMENT_START_STACK	7
#define	MAX_PROC_SEGMENT	8
#define	PROC_ARGS_SIZE	0
#define	MAX_PROC_ARGS	1
#define	PROC_MAP_NUMBER	0
#define	PROC_MAP_TOTAL	1
#define	PROC_MAP_SIZE	2
#define	MAX_PROC_MAP	3
#define	MAP_ENTRY_START	0
#define	MAP_ENTRY_END	1
#define	MAP_ENTRY_OFFSET	2
#define	MAP_ENTRY_PERM	3
#define	MAP_ENTRY_INODE	4
#define	MAP_ENTRY_DEVICE	5
#define	MAP_ENTRY_FILENAME	6
#define	MAX_MAP_ENTRY	7
#define	MAP_FILENAME_LEN	215
#define	MAP_PERM_READ	1
#define	MAP_PERM_WRITE	2
#define	MAP_PERM_EXECUTE	4
#define	MAP_PERM_SHARED	8
#define	MAP_PERM_PRIVATE	16
#define	MOUNTLIST_NUMBER	0
#define	MOUNTLIST_TOTAL	1
#define	MOUNTLIST_SIZE	2
#define	MAX_MOUNTLIST	3
#define	FSUSAGE_BLOCKS	0
#define	FSUSAGE_BFREE	1
#define	FSUSAGE_BAVAIL	2
#define	FSUSAGE_FILES	3
#define	FSUSAGE_FFREE	4
#define	FSUSAGE_BLOCK_SIZE	5
#define	MAX_FSUSAGE	6
