#include <stdio.h>
#include <sys/types.h>

#include <glibtop.h>
#include <glibtop/cpu.h>
#include <glibtop/loadavg.h>
#include <glibtop/mem.h>
#include <glibtop/swap.h>
#include <glibtop/ppp.h>
#include <glibtop/netload.h>
#include <glibtop/uptime.h>
#include <glibtop/proclist.h>
#include <glibtop/procstate.h>
#include <glibtop/procuid.h>
#include <glibtop/procmem.h>
#include <glibtop/proctime.h>
#include <glibtop/procsignal.h>
#include <glibtop/prockernel.h>
#include <glibtop/procsegment.h>
#include <glibtop/procargs.h>
#include <glibtop/procmap.h>
#include <glibtop/mountlist.h>
#include <glibtop/fsusage.h>


#define SKIP_GLIBTOP_(X) (X+sizeof("GLIBTOP_")-1)

#define PRINT_VALUE(X, V) printf("#define\t%s\t%u\n", SKIP_GLIBTOP_(#X), V)

#define PRINT(X) printf("#define\t%s\t%u\n", SKIP_GLIBTOP_(#X), X)


int main()
{
  putchar('\n');
  putchar('\n');
  putchar('\n');

  PRINT(GLIBTOP_MOUNTENTRY_LEN);

  PRINT(GLIBTOP_CPU_TOTAL);
  PRINT(GLIBTOP_CPU_USER);
  PRINT(GLIBTOP_CPU_NICE);
  PRINT(GLIBTOP_CPU_SYS);
  PRINT(GLIBTOP_CPU_IDLE);
  PRINT(GLIBTOP_CPU_FREQUENCY);
  PRINT(GLIBTOP_XCPU_TOTAL);
  PRINT(GLIBTOP_XCPU_USER);
  PRINT(GLIBTOP_XCPU_NICE);
  PRINT(GLIBTOP_XCPU_SYS);
  PRINT(GLIBTOP_XCPU_IDLE);
  PRINT(GLIBTOP_MAX_CPU);

  PRINT(GLIBTOP_NCPU);


  PRINT(GLIBTOP_LOADAVG_LOADAVG);
  PRINT(GLIBTOP_LOADAVG_NR_RUNNING);
  PRINT(GLIBTOP_LOADAVG_NR_TASKS);
  PRINT(GLIBTOP_LOADAVG_LAST_PID);
  PRINT(GLIBTOP_MAX_LOADAVG);

  PRINT(GLIBTOP_MEM_TOTAL);
  PRINT(GLIBTOP_MEM_USED);
  PRINT(GLIBTOP_MEM_FREE);
  PRINT(GLIBTOP_MEM_SHARED);
  PRINT(GLIBTOP_MEM_BUFFER);
  PRINT(GLIBTOP_MEM_CACHED);
  PRINT(GLIBTOP_MEM_USER);
  PRINT(GLIBTOP_MEM_LOCKED);
  PRINT(GLIBTOP_MAX_MEM);

  PRINT(GLIBTOP_SWAP_TOTAL);
  PRINT(GLIBTOP_SWAP_USED);
  PRINT(GLIBTOP_SWAP_FREE);
  PRINT(GLIBTOP_SWAP_PAGEIN);
  PRINT(GLIBTOP_SWAP_PAGEOUT);
  PRINT(GLIBTOP_MAX_SWAP);

  PRINT(GLIBTOP_PPP_STATE);
  PRINT(GLIBTOP_PPP_BYTES_IN);
  PRINT(GLIBTOP_PPP_BYTES_OUT);
  PRINT(GLIBTOP_MAX_PPP);
  PRINT(GLIBTOP_PPP_STATE_UNKNOWN);
  PRINT(GLIBTOP_PPP_STATE_HANGUP);
  PRINT(GLIBTOP_PPP_STATE_ONLINE);

  PRINT(GLIBTOP_NETLOAD_IF_FLAGS);
  PRINT(GLIBTOP_NETLOAD_MTU);
  PRINT(GLIBTOP_NETLOAD_SUBNET);
  PRINT(GLIBTOP_NETLOAD_ADDRESS);
  PRINT(GLIBTOP_NETLOAD_PACKETS_IN);
  PRINT(GLIBTOP_NETLOAD_PACKETS_OUT);
  PRINT(GLIBTOP_NETLOAD_PACKETS_TOTAL);
  PRINT(GLIBTOP_NETLOAD_BYTES_IN);
  PRINT(GLIBTOP_NETLOAD_BYTES_OUT);
  PRINT(GLIBTOP_NETLOAD_BYTES_TOTAL);
  PRINT(GLIBTOP_NETLOAD_ERRORS_IN);
  PRINT(GLIBTOP_NETLOAD_ERRORS_OUT);
  PRINT(GLIBTOP_NETLOAD_ERRORS_TOTAL);
  PRINT(GLIBTOP_NETLOAD_COLLISIONS);
  PRINT(GLIBTOP_MAX_NETLOAD);
  PRINT(GLIBTOP_IF_FLAGS_UP);
  PRINT(GLIBTOP_IF_FLAGS_BROADCAST);
  PRINT(GLIBTOP_IF_FLAGS_DEBUG);
  PRINT(GLIBTOP_IF_FLAGS_LOOPBACK);
  PRINT(GLIBTOP_IF_FLAGS_POINTOPOINT);
  PRINT(GLIBTOP_IF_FLAGS_RUNNING);
  PRINT(GLIBTOP_IF_FLAGS_NOARP);
  PRINT(GLIBTOP_IF_FLAGS_PROMISC);
  PRINT(GLIBTOP_IF_FLAGS_ALLMULTI);
  PRINT(GLIBTOP_IF_FLAGS_OACTIVE);
  PRINT(GLIBTOP_IF_FLAGS_SIMPLEX);
  PRINT(GLIBTOP_IF_FLAGS_LINK0);
  PRINT(GLIBTOP_IF_FLAGS_LINK1);
  PRINT(GLIBTOP_IF_FLAGS_LINK2);
  PRINT(GLIBTOP_IF_FLAGS_ALTPHYS);
  PRINT(GLIBTOP_IF_FLAGS_MULTICAST);

  PRINT(GLIBTOP_UPTIME_UPTIME);
  PRINT(GLIBTOP_UPTIME_IDLETIME);

#ifdef GLIBTOP_UPTIME_BOOT_TIME
  PRINT(GLIBTOP_UPTIME_BOOT_TIME);
  PRINT(GLIBTOP_MAX_UPTIME);
#else
  /* GLIBTOP_UPTIME_BOOT_TIME not available
     lets add the bootime value at the end of the C struct
  */
  PRINT_VALUE(GLIBTOP_UPTIME_BOOT_TIME, GLIBTOP_MAX_UPTIME);
  PRINT_VALUE(GLIBTOP_MAX_UPTIME, GLIBTOP_MAX_UPTIME + 1);
#endif

  PRINT(GLIBTOP_PROCLIST_NUMBER);
  PRINT(GLIBTOP_PROCLIST_TOTAL);
  PRINT(GLIBTOP_PROCLIST_SIZE);
  PRINT(GLIBTOP_MAX_PROCLIST);
  PRINT(GLIBTOP_KERN_PROC_ALL);
  PRINT(GLIBTOP_KERN_PROC_PID);
  PRINT(GLIBTOP_KERN_PROC_PGRP);
  PRINT(GLIBTOP_KERN_PROC_SESSION);
  PRINT(GLIBTOP_KERN_PROC_TTY);
  PRINT(GLIBTOP_KERN_PROC_UID);
  PRINT(GLIBTOP_KERN_PROC_RUID);
  PRINT(GLIBTOP_KERN_PROC_MASK);
  PRINT(GLIBTOP_EXCLUDE_IDLE);
  PRINT(GLIBTOP_EXCLUDE_SYSTEM);
  PRINT(GLIBTOP_EXCLUDE_NOTTY);

  PRINT(GLIBTOP_PROC_STATE_CMD);
  PRINT(GLIBTOP_PROC_STATE_STATE);
  PRINT(GLIBTOP_PROC_STATE_UID);
  PRINT(GLIBTOP_PROC_STATE_GID);
  PRINT(GLIBTOP_MAX_PROC_STATE);

  PRINT(GLIBTOP_PROC_UID_UID);
  PRINT(GLIBTOP_PROC_UID_EUID);
  PRINT(GLIBTOP_PROC_UID_GID);
  PRINT(GLIBTOP_PROC_UID_EGID);
  PRINT(GLIBTOP_PROC_UID_PID);
  PRINT(GLIBTOP_PROC_UID_PPID);
  PRINT(GLIBTOP_PROC_UID_PGRP);
  PRINT(GLIBTOP_PROC_UID_SESSION);
  PRINT(GLIBTOP_PROC_UID_TTY);
  PRINT(GLIBTOP_PROC_UID_TPGID);
  PRINT(GLIBTOP_PROC_UID_PRIORITY);
  PRINT(GLIBTOP_PROC_UID_NICE);
  PRINT(GLIBTOP_MAX_PROC_UID);

  PRINT(GLIBTOP_PROC_MEM_SIZE);
  PRINT(GLIBTOP_PROC_MEM_VSIZE);
  PRINT(GLIBTOP_PROC_MEM_RESIDENT);
  PRINT(GLIBTOP_PROC_MEM_SHARE);
  PRINT(GLIBTOP_PROC_MEM_RSS);
  PRINT(GLIBTOP_PROC_MEM_RSS_RLIM);
  PRINT(GLIBTOP_MAX_PROC_MEM);

  PRINT(GLIBTOP_PROC_TIME_START_TIME);
  PRINT(GLIBTOP_PROC_TIME_RTIME);
  PRINT(GLIBTOP_PROC_TIME_UTIME);
  PRINT(GLIBTOP_PROC_TIME_STIME);
  PRINT(GLIBTOP_PROC_TIME_CUTIME);
  PRINT(GLIBTOP_PROC_TIME_CSTIME);
  PRINT(GLIBTOP_PROC_TIME_TIMEOUT);
  PRINT(GLIBTOP_PROC_TIME_IT_REAL_VALUE);
  PRINT(GLIBTOP_PROC_TIME_FREQUENCY);
  PRINT(GLIBTOP_PROC_TIME_XCPU_UTIME);
  PRINT(GLIBTOP_PROC_TIME_XCPU_STIME);
  PRINT(GLIBTOP_MAX_PROC_TIME);

  PRINT(GLIBTOP_PROC_SIGNAL_SIGNAL);
  PRINT(GLIBTOP_PROC_SIGNAL_BLOCKED);
  PRINT(GLIBTOP_PROC_SIGNAL_SIGIGNORE);
  PRINT(GLIBTOP_PROC_SIGNAL_SIGCATCH);
  PRINT(GLIBTOP_MAX_PROC_SIGNAL);

  PRINT(GLIBTOP_PROC_KERNEL_K_FLAGS);
  PRINT(GLIBTOP_PROC_KERNEL_MIN_FLT);
  PRINT(GLIBTOP_PROC_KERNEL_MAJ_FLT);
  PRINT(GLIBTOP_PROC_KERNEL_CMIN_FLT);
  PRINT(GLIBTOP_PROC_KERNEL_CMAJ_FLT);
  PRINT(GLIBTOP_PROC_KERNEL_KSTK_ESP);
  PRINT(GLIBTOP_PROC_KERNEL_KSTK_EIP);
  PRINT(GLIBTOP_PROC_KERNEL_NWCHAN);
  PRINT(GLIBTOP_PROC_KERNEL_WCHAN);
  PRINT(GLIBTOP_MAX_PROC_KERNEL);

  PRINT(GLIBTOP_PROC_SEGMENT_TEXT_RSS);
  PRINT(GLIBTOP_PROC_SEGMENT_SHLIB_RSS);
  PRINT(GLIBTOP_PROC_SEGMENT_DATA_RSS);
  PRINT(GLIBTOP_PROC_SEGMENT_STACK_RSS);
  PRINT(GLIBTOP_PROC_SEGMENT_DIRTY_SIZE);
  PRINT(GLIBTOP_PROC_SEGMENT_START_CODE);
  PRINT(GLIBTOP_PROC_SEGMENT_END_CODE);
  PRINT(GLIBTOP_PROC_SEGMENT_START_STACK);
  PRINT(GLIBTOP_MAX_PROC_SEGMENT);

  PRINT(GLIBTOP_PROC_ARGS_SIZE);
  PRINT(GLIBTOP_MAX_PROC_ARGS);

  PRINT(GLIBTOP_PROC_MAP_NUMBER);
  PRINT(GLIBTOP_PROC_MAP_TOTAL);
  PRINT(GLIBTOP_PROC_MAP_SIZE);
  PRINT(GLIBTOP_MAX_PROC_MAP);
  PRINT(GLIBTOP_MAP_ENTRY_START);
  PRINT(GLIBTOP_MAP_ENTRY_END);
  PRINT(GLIBTOP_MAP_ENTRY_OFFSET);
  PRINT(GLIBTOP_MAP_ENTRY_PERM);
  PRINT(GLIBTOP_MAP_ENTRY_INODE);
  PRINT(GLIBTOP_MAP_ENTRY_DEVICE);
  PRINT(GLIBTOP_MAP_ENTRY_FILENAME);
  PRINT(GLIBTOP_MAX_MAP_ENTRY);
  PRINT(GLIBTOP_MAP_FILENAME_LEN);
  PRINT(GLIBTOP_MAP_PERM_READ);
  PRINT(GLIBTOP_MAP_PERM_WRITE);
  PRINT(GLIBTOP_MAP_PERM_EXECUTE);
  PRINT(GLIBTOP_MAP_PERM_SHARED);
  PRINT(GLIBTOP_MAP_PERM_PRIVATE);

  PRINT(GLIBTOP_MOUNTLIST_NUMBER);
  PRINT(GLIBTOP_MOUNTLIST_TOTAL);
  PRINT(GLIBTOP_MOUNTLIST_SIZE);
  PRINT(GLIBTOP_MAX_MOUNTLIST);

  PRINT(GLIBTOP_FSUSAGE_BLOCKS);
  PRINT(GLIBTOP_FSUSAGE_BFREE);
  PRINT(GLIBTOP_FSUSAGE_BAVAIL);
  PRINT(GLIBTOP_FSUSAGE_FILES);
  PRINT(GLIBTOP_FSUSAGE_FFREE);

#ifdef GLIBTOP_FSUSAGE_BLOCK_SIZE
  PRINT(GLIBTOP_FSUSAGE_BLOCK_SIZE);
  PRINT(GLIBTOP_MAX_FSUSAGE);
#else
  /* GLIBTOP_FSUSAGE_BLOCK_SIZE not available
     lets add the fsusage value at the end of the C struct
  */
  PRINT_VALUE(GLIBTOP_FSUSAGE_BLOCK_SIZE, GLIBTOP_MAX_FSUSAGE);
  PRINT_VALUE(GLIBTOP_MAX_FSUSAGE, GLIBTOP_MAX_FSUSAGE + 1);
#endif

  return 0;
}
