/* Functions for rendering SVG onto a GtkImage.
 * Copyright (C) 2004 Martin Grimme
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */

#include <gtk/gtk.h>
#include <librsvg/rsvg.h>
#include <gdk-pixbuf/gdk-pixbuf.h>


void
render_svg (GtkImage *image, int width, int height, char* data,
            int length)
{
  GdkPixbuf *pbuf;
  GError *error = NULL;
  RsvgHandle *handle = rsvg_handle_new ();
  rsvg_handle_write (handle, (const guchar *) data, length, &error);
  rsvg_handle_close (handle, &error);
  pbuf = rsvg_handle_get_pixbuf (handle);
  rsvg_handle_free (handle);
  gtk_image_set_from_pixbuf (image, pbuf);
  g_object_unref (G_OBJECT (pbuf));
}
