/* Functions for using the systray.
 * Copyright (C) 2004 Martin Grimme
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */
#include <Python.h>
#include <gtk/gtk.h>
#include "eggtrayicon.h"

EggTrayIcon *
systray_icon_new (char *name)
{
  EggTrayIcon *icon;
  icon = egg_tray_icon_new ((const gchar *) name);
  gtk_widget_show (GTK_WIDGET (icon));
  
  return icon;
}

void
systray_icon_destroy (EggTrayIcon *icon)
{
  g_object_unref (G_OBJECT (icon));
}

void
systray_icon_add (EggTrayIcon *icon, GtkWidget *child)
{
  gtk_container_add (GTK_CONTAINER (icon), child);
}
